package org.me.richtest.sys;

import java.io.Serializable;
import java.util.Date;
import java.util.Properties;

import javax.faces.bean.ManagedBean;
import javax.faces.bean.SessionScoped;
import javax.faces.event.AjaxBehaviorEvent;
import javax.jms.ObjectMessage;
import javax.jms.TextMessage;
import javax.jms.Topic;
import javax.jms.TopicConnection;
import javax.jms.TopicConnectionFactory;
import javax.jms.TopicPublisher;
import javax.jms.TopicSession;
import javax.naming.InitialContext;

import org.me.richtest.vo.BroadCastMessage;

@SessionScoped
@ManagedBean
public class JMSTopicPublisher implements Serializable {

	/**
	 * 
	 */
	private static final long serialVersionUID = 4740749606273687457L;

	public JMSTopicPublisher() {
		// TODO Auto-generated constructor stub
	}

	public void sendMessage(AjaxBehaviorEvent event) {
		// System.out.println(event);
		sendMessage();
	}


	private void sendMessage() {
		Properties props = new Properties();
		props.setProperty("java.naming.factory.initial",
				"org.jnp.interfaces.NamingContextFactory");
		props.setProperty("java.naming.factory.url.pkgs", "org.jboss.naming");
		props.setProperty("java.naming.provider.url", "localhost");
		TopicConnection conn = null;
		TopicSession session = null;
		Topic topic = null;
		try {
			InitialContext iniCtx = new InitialContext(props);
			Object tmp = iniCtx.lookup("ConnectionFactory");
			TopicConnectionFactory tcf = (TopicConnectionFactory) tmp;
			conn = tcf.createTopicConnection("guest", "guest");
			topic = (Topic) iniCtx.lookup("topic/broadcastTopic");
			session = conn.createTopicSession(false,
					TopicSession.CLIENT_ACKNOWLEDGE);
			conn.start();
			TopicPublisher publisher= session.createPublisher(topic);
			
			TextMessage textMessage=session.createTextMessage("Sample Text Message");
			textMessage.setStringProperty("rf_push_subtopic", "ANY");			
			publisher.publish(textMessage);
			
			ObjectMessage message = session
					.createObjectMessage(new BroadCastMessage("Sample Object Message",
							new Date().toString()));
			message.setStringProperty("rf_push_subtopic", "ANY");
			publisher.publish(message);
		} catch (Exception e) {
			throw new RuntimeException(e);
		}finally{
			if (conn != null) {
				try {
					conn.close();
				} catch (Exception ex) {

				}
			}
		}
	}

}
